<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for respuestaConfiguracion StructType
 * @subpackage Structs
 */
class RespuestaConfiguracion extends ModelDto
{
    /**
     * The mensajesList
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MensajeServicio[]
     */
    public $mensajesList;
    /**
     * The transaccion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $transaccion;
    /**
     * Constructor method for respuestaConfiguracion
     * @uses RespuestaConfiguracion::setMensajesList()
     * @uses RespuestaConfiguracion::setTransaccion()
     * @param \StructType\MensajeServicio[] $mensajesList
     * @param bool $transaccion
     */
    public function __construct(array $mensajesList = array(), $transaccion = null)
    {
        $this
            ->setMensajesList($mensajesList)
            ->setTransaccion($transaccion);
    }
    /**
     * Get mensajesList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MensajeServicio[]|null
     */
    public function getMensajesList()
    {
        return isset($this->mensajesList) ? $this->mensajesList : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMensajesList method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMensajesList method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMensajesListForArrayConstraintsFromSetMensajesList(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $respuestaConfiguracionMensajesListItem) {
            // validation for constraint: itemType
            if (!$respuestaConfiguracionMensajesListItem instanceof \StructType\MensajeServicio) {
                $invalidValues[] = is_object($respuestaConfiguracionMensajesListItem) ? get_class($respuestaConfiguracionMensajesListItem) : sprintf('%s(%s)', gettype($respuestaConfiguracionMensajesListItem), var_export($respuestaConfiguracionMensajesListItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The mensajesList property can only contain items of type \StructType\MensajeServicio, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set mensajesList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MensajeServicio[] $mensajesList
     * @return \StructType\RespuestaConfiguracion
     */
    public function setMensajesList(array $mensajesList = array())
    {
        // validation for constraint: array
        if ('' !== ($mensajesListArrayErrorMessage = self::validateMensajesListForArrayConstraintsFromSetMensajesList($mensajesList))) {
            throw new \InvalidArgumentException($mensajesListArrayErrorMessage, __LINE__);
        }
        if (is_null($mensajesList) || (is_array($mensajesList) && empty($mensajesList))) {
            unset($this->mensajesList);
        } else {
            $this->mensajesList = $mensajesList;
        }
        return $this;
    }
    /**
     * Add item to mensajesList value
     * @throws \InvalidArgumentException
     * @param \StructType\MensajeServicio $item
     * @return \StructType\RespuestaConfiguracion
     */
    public function addToMensajesList(\StructType\MensajeServicio $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MensajeServicio) {
            throw new \InvalidArgumentException(sprintf('The mensajesList property can only contain items of type \StructType\MensajeServicio, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->mensajesList[] = $item;
        return $this;
    }
    /**
     * Get transaccion value
     * @return bool|null
     */
    public function getTransaccion()
    {
        return $this->transaccion;
    }
    /**
     * Set transaccion value
     * @param bool $transaccion
     * @return \StructType\RespuestaConfiguracion
     */
    public function setTransaccion($transaccion = null)
    {
        // validation for constraint: boolean
        if (!is_null($transaccion) && !is_bool($transaccion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($transaccion, true), gettype($transaccion)), __LINE__);
        }
        $this->transaccion = $transaccion;
        return $this;
    }
}
